import os
import traceback
import subprocess

from astra_installer.settings.systeminfo import AstraEdition


class Utils:
    @classmethod
    def file_path(cls, *paths) -> str:
        package_directory = os.path.dirname(os.path.abspath(__file__))
        return os.path.join(package_directory, *paths)

    @classmethod
    def is_current_process_has_max_mic(cls) -> bool:
        try:
            with open('/sys/module/parsec/parameters/max_ilev', 'r') as parsec_max_ilev:
                max_ilev = int(parsec_max_ilev.readline())
            current_ilev = int(subprocess.check_output(['pdp-id', '-i']))
            return max_ilev == 0 or max_ilev == current_ilev
        except:
            print('Failed to get current ilev.')
            traceback.print_exc()
            return True
